---
layout: markdown_page
title: "Category Strategy - Geo-replication"
description: "Using Geo replications reduces the time it needs to fetch and clone repositories, which increases developer productivity. Learn more here!"
canonical_path: "/direction/geo/geo_replication/"
---

- TOC
{:toc}

## 🌏 Geo-replication

**Last updated**: 2020-12-23

### Introduction and how you can help

- [Overall Strategy](/direction/geo)
- [Roadmap for Geo Replication](https://gitlab.com/groups/gitlab-org/-/roadmap?scope=all&utf8=%E2%9C%93&state=opened&label_name[]=group%3A%3Ageo&label_name[]=geo%3A%3Aactive)
- [Maturity: <%= data.categories["geo_replication"].maturity.capitalize %>](/direction/maturity/)
- [Documentation](https://docs.gitlab.com/ee/administration/geo/replication/)
- [Complete Maturity epic](https://gitlab.com/groups/gitlab-org/-/epics/1508)
- [All Epics](https://gitlab.com/groups/gitlab-org/-/epics?scope=all&utf8=%E2%9C%93&state=opened&label_name[]=group%3A%3Ageo)

The Geo-replication category helps distributed developer teams be more
productive. With a single GitLab instance working with large repositories can
take a long time for developers located in different geographies.
Geo-replication provides an easily configurable, read-only mirror (we call it a
Geo site) of a GitLab installation that is complete, accurate, verifiable and
efficient. This is valuable because using Geo reduces the time it needs to
fetch and clone repositories, which increases developer productivity.

Please reach out to Fabian Zimmer, Product Manager for the Geo group
([Email](mailto:fzimmer@gitlab.com)) if you'd like to provide feedback or ask
any questions related to this product category.

This strategy is a work in progress, and everyone can contribute. Please comment and contribute in the linked
[issues](https://gitlab.com/groups/gitlab-org/-/issues?scope=all&utf8=%E2%9C%93&state=opened&label_name[]=group%3A%3Ageo) and [epics](https://gitlab.com/groups/gitlab-org/-/epics?scope=all&utf8=%E2%9C%93&state=opened&label_name[]=group%3A%3Ageo) on this page. Sharing your feedback directly on GitLab.com is the best way to contribute to our strategy and vision.

### Overview

Geo-replication requires a significant investment to be
configured by systems administrators but allows users in different locations to
accelerate `git` read operations. Write requests are transparently proxied to the
primary site. Geo replicates around [80% of the data generated by GitLab](https://docs.gitlab.com/ee/administration/geo/replication/datatypes.html#limitations-on-replicationverification) and
a number of data types [can be disabled if required](https://docs.gitlab.com/ee/administration/geo/replication/datatypes.html#replicated-data-types-behind-a-feature-flag).

### Where we are headed

Our goal for Geo-replication is to offer the same experience to users,
regardless of their location. In the future, we want our users to be able to
configure Geo within minutes - not hours. We envision Geo-replication to be
fully transparent to users. This means that a developer should not need to
actively decide to use Geo, or select the right Geo site - GitLab should be able
to determine what Geo site should be used to provide the best user experience.
For systems administrators, it should be simple to add, configure and remove new
sites.

- Pulls and clones of git repositories should be fast everywhere - especially for large repositories.
- Users should not be required to configure geo-replication manually - we should detect the best Geo site automatically.
- Geo-replication should be easy to set-up and configure - new Geo site should be added with minimal effort.
- Geo-replication should be fully transparent for users - ideally a user of GitLab does not even notice that they are using a Geo site.
- Geo-replication should allow fine-grained control over what is replicated where - not every project and repository needs to be shared.
- All data types generated by GitLab should be replicated and verified.

### Target audience and experience

#### [Sidney (Systems Administrator)](https://about.gitlab.com/handbook/marketing/strategic-marketing/roles-personas/#sidney-systems-administrator)

- 🙂 **Minimal** - Sidney is able to configure the Geo-replication setup manually, most commonly used data types are replicated.
- 😊 **Viable** - Sidney is able to configure Geo-replication in a mostly automated fashion. Various Geo-replication tasks (status reports, maintenance etc.) can be performed using the GitLab UI. All customer relevant data types are replicated.
- 😁 **Complete** - Sidney can setup Geo in an automated and fast way (minutes, not hours). A dashboard provides an overview for all relevant Geo tasks.
- 😍 **Lovable** - Sidney can setup Geo in an automated and fast way and everything is configurable from the UI, all nodes appear writable.

#### [Sasha (Software Developer)](https://about.gitlab.com/handbook/marketing/strategic-marketing/roles-personas/#sasha-software-developer)

- 🙂 **Minimal** - Sasha has to configure Git manually to use Geo. No automatic proxying of request to the primary. WebUI on secondary is not available.
- 😊 **Viable** - Sasha has to configure Git manually but automatic proxying to the primary is possible. WebUI is read-only.
- 😁 **Complete** - Sasha only requires a single URL for all operations - the correct Geo site is used automatically
- 😍 **Lovable** - Sasha can push and pull directly to a Geo site. Everything is read and writable, including the WebUI. The user experience is the same independent of location.

For more information on how we use personas and roles at GitLab, please [click
here](https://about.gitlab.com/handbook/marketing/strategic-marketing/roles-personas/).

### What's next & why

#### Instrument usage ping

We need to understand better how software developers interact with secondary sites.
As a next step, we are going to track [Git operations performed on secondary sites](https://gitlab.com/gitlab-org/gitlab/-/issues/273199). This data will help us understand usage patterns
and how we can improve the overall user experience.

#### Geo automatically chooses the best GitLab site

Using a Geo site to overcome UX issues (e.g. latency)  requires additional configuration for software developers, which is cumbersome. Using the secondary Web interface is a worse user experience than using the primary. A software developer needs to switch between a primary and secondary frequently, which can be highly confusing and frustrating.

We plan to [automatically choose the best Geo node](https://gitlab.com/groups/gitlab-org/-/epics/1466). This means that Geo will forward any requests from a secondary to a primary *unless* the user experience can be significantly improved by using the secondary. This will likely result in the deprecation of the read-only web interface because requests will be proxied from a secondary to a primary.

#### Package file verification

We are working on supporting more and more data types using a [self-service framework](https://docs.gitlab.com/ee/development/geo/framework.html) and are adding verification capabilities to
the framework to ensure that data was not corrupted during transfer or at rest.
Following support for [package file verification](https://gitlab.com/groups/gitlab-org/-/epics/1817), LFS files will be supported next
via the self-service framework.

### In a year

#### Geo should be easy to setup

Setting up Geo is highly manual and cumbersome, especially in high-availability
configurations. In the beginning of 2021, we are going to start
investigating how we can [simplify Geo's
setup](https://gitlab.com/groups/gitlab-org/-/epics/1465) - especially for single-node Geo sites.

#### Geo supports an advanced caching mode

For Geo-replication only a subset of data may need to be replicated but Geo sites require spinning up the entire GitLab stack, less may be sufficient. Additionally, systems administrators can select a subset via selective sync, but they may be wrong.

We are investigating an [advanced caching mode](https://gitlab.com/groups/gitlab-org/-/epics/2610) with the following properties:

- A Geo node that dynamically determines which data needs to be kept close to the remote location
- Minimal hardware requirements
- Fully hidden behind geo-location aware URL

### What is not planned right now

We are currently not planning on moving away from Postgres as a backend database
in favour of e.g CockroachDB or Google Spanner. This has implications for
multi-mode Geo, but for now we will continue to support PostgreSQL.

#### Writable Geo sites

Geo secondary sites are read-only. Customer feedback has indicated a desire for additional
[Active active git replication](https://gitlab.com/gitlab-org/gitlab/-/issues/1381). With the availability of [Gitaly Cluster](https://docs.gitlab.com/ee/administration/gitaly/praefect.html) we may start investigating writable Geo sites in FY22.

### Maturity plan

This category is currently at the `viable` maturity level, and our next maturity
target is `complete` (see our [definitions of maturity
levels](/direction/maturity/#legend).

You can track the work that will move the category to `complete` in
[this epic](https://gitlab.com/groups/gitlab-org/-/epics/1508).

### Metrics

- Performance indicator is [number of unique users utilizing a Geo secondary](https://about.gitlab.com/handbook/product/enablement-section-performance-indicators/#enablementgeo---paid-gmau---number-of-unique-users-utilizing-a-geo-secondary)
- We track the [total number of Geo sites and potential users](https://app.periscopedata.com/app/gitlab/500159/Enablement::Geo-Metrics?widget=9939914&udv=0)
- We track the [distribution of Geo site number](https://app.periscopedata.com/app/gitlab/500159/Enablement::Geo-Metrics?widget=6471733&udv=0)

### Competitive landscape

The top competitors for Geo-replication are

- [GitHub Enterprise geo-replication](https://help.github.com/en/enterprise/2.17/admin/installation/about-geo-replication)
- [Azure DevOps](https://azure.microsoft.com/en-in/services/devops/)
- [Bitbucket Smart Mirroring](https://confluence.atlassian.com/bitbucket/work-with-bitbucket-smart-mirroring-838427532.html)

#### Feature overview

| Feature                     | GitHub | AzureDevOps | Bitbucket Smart Mirroring | GitLab |
|-----------------------------|--------|-------------|---------------------------|--------|
| Mirror repositories         | ✅      | ✅           | ✅                         | ✅      |
| Active-active replication   | ❌      | N/A         | ❌                         | ❌      |
| Selective sync              | N/A    | N/A         | ✅                         | ⚠️      |
| UI configuration            | ❌      | ✅           | N/A                       | ⚠️      |
| Kubernetes support          | ❌      | ❌           | ❌                         | ⚠️      |
| Mirror docker registries    | ❌      | N/A         | ❌                         | ✅      |
| LFS and file upload support | ✅      | N/A         | ✅                         | ✅      |
| Automatic DNS               | ✅      | ✅           | ❌                         | ⚠️      |
| GUI Dashboard               | ✅      | ✅           | N/A                       | ✅      |
| Request proxying            | ✅      | N/A         | N/A                       | ⚠️      |

 ✅ Fully available
 ⚠️ Partially available
 ❌ Not available
 N/A No information available

### Analyst landscape

We do need to engage with analysts more closely to understand the current landscape better.

### Top customer success/sales issue(s)

- [https://gitlab.com/gitlab-org/gitlab-ee/issues/2870](https://gitlab.com/gitlab-org/gitlab-ee/issues/2870)
- [Active active git replication](https://gitlab.com/gitlab-org/gitlab/-/issues/1381)

### Top user issues

- [Category issues listed by popularity](https://gitlab.com/groups/gitlab-org/-/issues?label_name%5B%5D=Geo&scope=all&sort=popularity&state=opened&utf8=%E2%9C%93)

### Top internal customer issues/epics

- [Build a scalable, self-service geo-replication and
verification framework](https://gitlab.com/groups/gitlab-org/-/epics/2161)

### Top strategy item(s)

- [Simplify Geo's installation](https://gitlab.com/groups/gitlab-org/-/epics/1465)
- [Secondary mimicry](https://gitlab.com/gitlab-org/gitlab/-/issues/207168)
